from django.contrib import admin
from b2eb_stat.models import Cluster, Server, Storage, Ssd, ClusterStorage

class ClusterAdmin(admin.ModelAdmin):
    list_display = ('name', 'owner','description')
    filter_horizontal = ('nodes', 'storage',)
    search_fields = ('name', 'fqdn',)

class StorageAdmin(admin.ModelAdmin,):
    list_display = ('array', 'capacity',)

class ServerAdmin(admin.ModelAdmin,):
    list_display = ('name', 'os', 'kernel',)
    search_fields = ('name', 'fqdn',)
    filter_horizontal = ('ssd',)

class SsdAdmin(admin.ModelAdmin,):
    search_fields = ('name', 'wwn',)
    list_display = ('name', 'type', 'vendor', 'capacity', 'wwn',)

admin.site.register(Cluster, ClusterAdmin)
admin.site.register(Server, ServerAdmin)
admin.site.register(Storage, StorageAdmin)
admin.site.register(Ssd, SsdAdmin)
admin.site.register(ClusterStorage)

